package worldcontrolteam.worldcontrol.client.gui;

import net.minecraft.client.gui.GuiButton;
import net.minecraft.client.gui.inventory.GuiContainer;
import net.minecraft.client.resources.I18n;
import net.minecraft.inventory.Container;
import net.minecraft.util.ResourceLocation;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import org.lwjgl.opengl.GL11;
import worldcontrolteam.worldcontrol.inventory.container.ContainerAverageCounter;
import worldcontrolteam.worldcontrol.utils.WCUtility;

@SideOnly(Side.CLIENT)
public class GuiAverageCounter extends GuiContainer {
    private static final String TEXTURE_FILE = "worldcontrol:textures/gui/gui_energy_counter.png";
    private static final ResourceLocation TEXTURE_LOCATION = new ResourceLocation(TEXTURE_FILE);

    private String name;
    private ContainerAverageCounter container;

    public GuiAverageCounter(Container container) {
        super(container);
        this.container = (ContainerAverageCounter) container;
        name = I18n.func_135052_a("tile.average_counter.name");
    }

    @SuppressWarnings("unchecked")
    private void initControls() {
        field_146292_n.clear();
        field_146292_n.add(new GuiButton(1, field_147003_i + 35, field_147009_r + 42, 30, 20, I18n.func_135052_a("1")));
        field_146292_n.add(new GuiButton(2, field_147003_i + 35 + 30, field_147009_r + 42, 30, 20, I18n.func_135052_a("3")));
        field_146292_n.add(new GuiButton(3, field_147003_i + 35 + 60, field_147009_r + 42, 30, 20, I18n.func_135052_a("5")));
        field_146292_n.add(new GuiButton(4, field_147003_i + 35 + 90, field_147009_r + 42, 30, 20, I18n.func_135052_a("10")));
    }

    @Override
    public void func_73866_w_() {
        super.func_73866_w_();
        initControls();
    }

    @Override
    protected void func_146979_b(int par1, int par2) {
        field_146289_q.func_78276_b(name, (field_146999_f - field_146289_q.func_78256_a(name)) / 2, 6, 0x404040);
        field_146289_q.func_78276_b(I18n.func_135052_a("container.inventory"), 8, field_147000_g - 96 + 2, 0x404040);
        String key = container.averageCounter.getPowerTranslateKey();
        String value = WCUtility.translateFormatted(key, container.averageCounter.getAverage());
        field_146289_q.func_78276_b(value, (field_146999_f - field_146289_q.func_78256_a(value)) / 2, 22, 0x404040);
        value = WCUtility.translateFormatted("average_counter_period", container.averageCounter.period);
        field_146289_q.func_78276_b(value, (field_146999_f - field_146289_q.func_78256_a(value)) / 2, 32, 0x404040);

    }

    @Override
    protected void func_146976_a(float var1, int var2, int var3) {
        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
        field_146297_k.field_71446_o.func_110577_a(TEXTURE_LOCATION);
        int left = (field_146294_l - field_146999_f) / 2;
        int top = (field_146295_m - field_147000_g) / 2;
        func_73729_b(left, top, 0, 0, field_146999_f, field_147000_g);
    }

    @Override
    public void func_73876_c() {
        super.func_73876_c();
        initControls();
    }

    @Override
    protected void func_146284_a(GuiButton guiButton) {
        short event = 0;
        switch (guiButton.field_146127_k) {
            case 1:
                event = 1;
                break;
            case 2:
                event = 3;
                break;
            case 3:
                event = 5;
                break;
            case 4:
                event = 10;
                break;
        }
        container.averageCounter.setPeriod(event);
    }
}
