package worldcontrolteam.worldcontrol.client.gui;

import net.minecraft.client.gui.GuiButton;
import net.minecraft.client.gui.GuiTextField;
import net.minecraft.client.gui.inventory.GuiContainer;
import net.minecraft.util.ResourceLocation;
import org.lwjgl.opengl.GL11;
import worldcontrolteam.worldcontrol.client.gui.features.CompactButton;
import worldcontrolteam.worldcontrol.client.gui.features.GuiThermoInvertRedstone;
import worldcontrolteam.worldcontrol.container.ContainerEmpty;
import worldcontrolteam.worldcontrol.network.ChannelHandler;
import worldcontrolteam.worldcontrol.network.messages.PacketClientUpdateMonitor;
import worldcontrolteam.worldcontrol.tileentity.TileEntityBaseReactorHeatMonitor;
import worldcontrolteam.worldcontrol.utils.WCUtility;

public class GuiReactorHeatMonitor extends GuiContainer {

    private static final String TEXTURE_FILE = "worldcontrol:textures/gui/guithermalmonitor.png";
    private static final ResourceLocation TEXTURE_LOCATION = new ResourceLocation(TEXTURE_FILE);
    String name;
    private TileEntityBaseReactorHeatMonitor heatMonitor;
    private GuiTextField textboxHeat = null;

    public GuiReactorHeatMonitor(TileEntityBaseReactorHeatMonitor tile) {
        super(new ContainerEmpty(tile));
        this.field_146999_f = 191;
        this.field_147000_g = 64;
        this.heatMonitor = tile;
        name = WCUtility.translate("thermalmonitorgui.name");
    }


    @Override
    public void func_73866_w_() {
        super.func_73866_w_();
        field_146292_n.clear();
        field_146292_n.add(new CompactButton(0, field_147003_i + 47, field_147009_r + 20, 22, 12, "-1"));
        field_146292_n.add(new CompactButton(1, field_147003_i + 47, field_147009_r + 31, 22, 12, "-10"));
        field_146292_n.add(new CompactButton(2, field_147003_i + 12, field_147009_r + 20, 36, 12, "-100"));
        field_146292_n.add(new CompactButton(3, field_147003_i + 12, field_147009_r + 31, 36, 12, "-1000"));
        field_146292_n.add(new CompactButton(4, field_147003_i + 12, field_147009_r + 42, 57, 12, "-10000"));

        field_146292_n.add(new CompactButton(5, field_147003_i + 122, field_147009_r + 20, 22, 12, "+1"));
        field_146292_n.add(new CompactButton(6, field_147003_i + 122, field_147009_r + 31, 22, 12, "+10"));
        field_146292_n.add(new CompactButton(7, field_147003_i + 143, field_147009_r + 20, 36, 12, "+100"));
        field_146292_n.add(new CompactButton(8, field_147003_i + 143, field_147009_r + 31, 36, 12, "+1000"));
        field_146292_n.add(new CompactButton(9, field_147003_i + 122, field_147009_r + 42, 57, 12, "+10000"));

        field_146292_n.add(new GuiThermoInvertRedstone(10, field_147003_i + 70, field_147009_r + 38, heatMonitor));

        textboxHeat = new GuiTextField(11, field_146289_q, 70, 21, 51, 12);
        textboxHeat.func_146195_b(true);
        textboxHeat.func_146180_a(String.valueOf(heatMonitor.getThreshhold()));
    }

    @Override
    public void func_73876_c() {
        super.func_73876_c();
        if (textboxHeat != null)
            textboxHeat.func_146178_a();
    }

    @Override
    public boolean func_73868_f() {
        return false;
    }

    @Override
    protected void func_146979_b(int par1, int par2) {
        field_146289_q.func_78276_b(name, (field_146999_f - field_146289_q.func_78256_a(name)) / 2, 6, 0x404040);

        if (textboxHeat != null)
            textboxHeat.func_146194_f();
    }

    @Override
    public void func_146281_b() {
        updateHeat(0);
        super.func_146281_b();
    }

    @Override
    protected void func_146284_a(GuiButton button) {
        if (button.field_146127_k >= 10)
            return;

        int delta = Integer.parseInt(button.field_146126_j.replace("+", ""));
        updateHeat(delta);
    }

    @Override
    protected void func_146976_a(float var1, int var2, int var3) {
        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
        field_146297_k.field_71446_o.func_110577_a(TEXTURE_LOCATION);
        int left = (field_146294_l - field_146999_f) / 2;
        int top = (field_146295_m - field_147000_g) / 2;
        func_73729_b(left, top, 0, 0, field_146999_f, field_147000_g);
    }

    @Override
    protected void func_73869_a(char par1, int par2) {
        if (par2 == 1)// Esc button
            field_146297_k.field_71439_g.func_71053_j();
        else if (par1 == 13)// Enter
            updateHeat(0);
        else if (textboxHeat != null && textboxHeat.func_146206_l() && (Character.isDigit(par1) || par1 == 0 || par1 == 8))
            textboxHeat.func_146201_a(par1, par2);
    }

    private void updateHeat(int delta) {
        if (textboxHeat != null) {
            int heat = 0;
            try {
                String value = textboxHeat.func_146179_b();
                if (!"".equals(value))
                    heat = Integer.parseInt(value);
            } catch (NumberFormatException e) {
                // do nothing
            }
            heat += delta;
            if (heat > 1000000)
                heat = 1000000;
            if (heat < 0)
                heat = 0;

            if (heatMonitor.getThreshhold() != heat) {
                heatMonitor.setThreshhold(heat);
                ChannelHandler.network.sendToServer(new PacketClientUpdateMonitor(heat, heatMonitor.getInversion(), heatMonitor.func_174877_v()));
            }
            textboxHeat.func_146180_a(new Integer(heat).toString());
        }
    }

}
