package worldcontrolteam.worldcontrol.client.gui.features;


import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.GuiButton;
import net.minecraft.client.resources.I18n;
import net.minecraft.util.ResourceLocation;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import org.lwjgl.opengl.GL11;
import worldcontrolteam.worldcontrol.network.ChannelHandler;
import worldcontrolteam.worldcontrol.network.messages.PacketUpdateHowlerAlarm;
import worldcontrolteam.worldcontrol.tileentity.TileEntityHowlerAlarm;
import worldcontrolteam.worldcontrol.utils.WCConfig;


@SideOnly(Side.CLIENT)
public class HowlerAlarmSlider extends GuiButton {
    private static final String TEXTURE_FILE = "worldcontrol:textures/gui/gui_howler_alarm.png";
    private static final ResourceLocation TEXTURE_LOCATION = new ResourceLocation(TEXTURE_FILE);

    public float sliderValue;
    public boolean dragging;
    private int minValue = 0;
    private int maxValue = 256;
    private int step = 8;
    private String label;
    private TileEntityHowlerAlarm alarm;

    public HowlerAlarmSlider(int id, int x, int y, String label, TileEntityHowlerAlarm alarm) {
        super(id, x, y, 107, 16, label);
        this.alarm = alarm;
        dragging = false;
        this.label = label;
        if (alarm.func_145831_w().field_72995_K)
            maxValue = WCConfig.maxAlarmRange;
        int currentRange = alarm.getRange();
        if (alarm.func_145831_w().field_72995_K && currentRange > maxValue)
            currentRange = maxValue;
        sliderValue = ((float) currentRange - minValue) / (maxValue - minValue);
        field_146126_j = I18n.func_135052_a(label, getNormalizedValue());
    }

    private int getNormalizedValue() {
        return (minValue + (int) Math.floor((maxValue - minValue) * sliderValue)) / step * step;
    }

    private void setSliderPos(int targetX) {
        sliderValue = (float) (targetX - (field_146128_h + 4)) / (float) (field_146120_f - 8);

        if (sliderValue < 0.0F)
            sliderValue = 0.0F;

        if (sliderValue > 1.0F)
            sliderValue = 1.0F;

        int newValue = getNormalizedValue();
        if (alarm.getRange() != newValue) {
            alarm.setRange(newValue);
            ChannelHandler.network.sendToServer(new PacketUpdateHowlerAlarm(newValue, "default", alarm.func_174877_v()));
        }
        field_146126_j = I18n.func_135052_a(label, newValue);
    }

    @Override
    public void func_191745_a(Minecraft minecraft, int targetX, int targetY, float f) {
        if (field_146125_m) {
            minecraft.field_71446_o.func_110577_a(TEXTURE_LOCATION);
            GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
            if (dragging)
                setSliderPos(targetX);

            func_73729_b(field_146128_h + (int) (sliderValue * (field_146120_f - 8)), field_146129_i, 131, 0, 8, 16);
            minecraft.field_71466_p.func_78276_b(field_146126_j, field_146128_h, field_146129_i - 12, 0x404040);
        }
    }

    @Override
    public boolean func_146116_c(Minecraft minecraft, int targetX, int j) {
        if (super.func_146116_c(minecraft, targetX, j)) {
            setSliderPos(targetX);
            dragging = true;
            return true;
        } else
            return false;
    }

    @Override
    public void func_146118_a(int i, int j) {
        super.func_146118_a(i, j);
        dragging = false;
    }
}
