package worldcontrolteam.worldcontrol.client.model.infopanel;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import net.minecraft.client.resources.IResource;
import net.minecraft.client.resources.IResourceManager;
import net.minecraft.util.ResourceLocation;
import net.minecraftforge.client.model.ICustomModelLoader;
import net.minecraftforge.client.model.IModel;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.Reader;

/**
 * File created by mincrmatt12 on 6/15/2018.
 * Originally written for WorldControl.
 * <p>
 * See LICENSE.txt for license information.
 */
public class ModelLoaderInfoPanel implements ICustomModelLoader {
    public static class ModelSpec {
        public String side;
        public String back;
    }

    IResourceManager rm;

    @Override
    public boolean accepts(ResourceLocation resourceLocation) {
        return resourceLocation.func_110623_a().endsWith("!worldcontrol:info_panel");
    }

    @Override
    public IModel loadModel(ResourceLocation resourceLocation) throws Exception {
        String path = resourceLocation.func_110623_a();
        path = path.replace("!worldcontrol:info_panel", "");
        IResource r = rm.func_110536_a(new ResourceLocation(resourceLocation.func_110624_b(), path + ".json"));
        Gson gson = new Gson();
        ModelSpec s = gson.fromJson(new InputStreamReader(r.func_110527_b()), ModelSpec.class);

        return new ModelInfoPanel(new ResourceLocation(s.side), new ResourceLocation(s.back));
    }

    @Override
    public void func_110549_a(IResourceManager iResourceManager) {
        rm = iResourceManager;
    }
}
