package worldcontrolteam.worldcontrol.container;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.Container;
import net.minecraft.inventory.IContainerListener;
import net.minecraft.inventory.Slot;
import net.minecraft.item.ItemStack;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import worldcontrolteam.worldcontrol.crossmod.industrialcraft2.blocks.TileEntityIC2RemoteReactorMonitor;
import worldcontrolteam.worldcontrol.inventory.SlotFilter;
import worldcontrolteam.worldcontrol.inventory.SlotFilterItemHandler;

import java.util.List;

public class ContainerIC2RemoteReactorMonitor extends Container {

    private EntityPlayer player;
    private TileEntityIC2RemoteReactorMonitor remoteHeatMonitor;
    private double lastEnergy = -1;

    public ContainerIC2RemoteReactorMonitor(EntityPlayer player, TileEntityIC2RemoteReactorMonitor remoteThermo) {
        super();

        this.player = player;
        this.remoteHeatMonitor = remoteThermo;

        //energy charger
        func_75146_a(new SlotFilterItemHandler(remoteThermo, 1, 13, 53));

        //upgrades
        func_75146_a(new SlotFilterItemHandler(remoteThermo, 0, 190, 8));
        func_75146_a(new SlotFilterItemHandler(remoteThermo, 2, 190, 26));
        func_75146_a(new SlotFilterItemHandler(remoteThermo, 3, 190, 44));
        func_75146_a(new SlotFilterItemHandler(remoteThermo, 4, 190, 62));

        //inventory
        for (int i = 0; i < 3; i++) {
            for (int k = 0; k < 9; k++) {
                func_75146_a(new Slot(player.field_71071_by, k + i * 9 + 9, 27 + k * 18, 84 + i * 18));
            }
        }

        for (int j = 0; j < 9; j++) {
            func_75146_a(new Slot(player.field_71071_by, j, 27 + j * 18, 142));
        }
    }

    @Override
    public void func_75142_b() {
        super.func_75142_b();
        int energy = (int) remoteHeatMonitor.getEnergy();
        for (int i = 0; i < this.field_75149_d.size(); i++) {
            IContainerListener crafting = (IContainerListener) this.field_75149_d.get(i);
            if (lastEnergy != energy) {
                crafting.func_71112_a(this, 0, energy);
            }
        }
        lastEnergy = energy;
    }

    public void func_75137_b(int type, int value) {
        if (type == 0) {
            remoteHeatMonitor.setEnergy(value);
        }
    }

    @Override
    public boolean func_75145_c(EntityPlayer var1) {
        return true;
    }
}
