package worldcontrolteam.worldcontrol.crossmod.industrialcraft2.blocks;

import net.minecraft.block.material.Material;
import net.minecraft.block.state.BlockStateContainer;
import net.minecraft.block.state.IBlockState;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.ChunkCache;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;
import net.minecraft.world.chunk.Chunk;
import worldcontrolteam.worldcontrol.blocks.BlockBasicRotate;
import worldcontrolteam.worldcontrol.tileentity.TileEntityBaseReactorHeatMonitor;
import worldcontrolteam.worldcontrol.utils.GuiLib;
import worldcontrolteam.worldcontrol.utils.WCUtility;

import static worldcontrolteam.worldcontrol.crossmod.industrialcraft2.blocks.BlockIC2ReactorMonitor.RENDER_TYPE;

public class BlockIC2RemoteReactorMonitor extends BlockBasicRotate {

    public BlockIC2RemoteReactorMonitor() {
        super(Material.field_151573_f, "ic2_remote_reactor_monitor");
        this.func_180632_j(this.func_176223_P().func_177226_a(RENDER_TYPE, BlockIC2ReactorMonitor.RenderType.NOT_FOUND).func_177226_a(BlockBasicRotate.FACING, EnumFacing.UP));
        this.defaultCreativeTab();
    }

    @Override
    public TileEntity createTile(World world, int meta) {
        return new TileEntityIC2RemoteReactorMonitor();
    }

    @Override
    public boolean hasGUI() {
        return true;
    }

    @Override
    public int guiID() {
        return GuiLib.IC2_REMOTE_HEAT_MONITOR;
    }

    @Override
    public int func_180656_a(IBlockState state, IBlockAccess world, BlockPos pos, EnumFacing facing) {
        return WCUtility.getTileEntity(world, pos, TileEntityIC2RemoteReactorMonitor.class).map(t -> t.isOverHeated() ? 15 : 0).orElse(0);
    }

    public boolean func_149744_f(IBlockState state)
    {
        return true;
    }

    @Override
    public IBlockState func_176203_a(int meta) {
        return this.func_176223_P().func_177226_a(FACING, EnumFacing.func_82600_a(meta));
    }

    @Override
    public int func_176201_c(IBlockState state) {
        return state.func_177229_b(FACING).func_176745_a();
    }

    @Override
    protected BlockStateContainer func_180661_e() {
        return new BlockStateContainer(this, FACING, RENDER_TYPE);
    }

    public IBlockState func_176221_a(IBlockState state, IBlockAccess world, BlockPos pos) {
        TileEntity tile = world instanceof ChunkCache ? ((ChunkCache) world).func_190300_a(pos, Chunk.EnumCreateEntityType.CHECK) : world.func_175625_s(pos);
        if (((TileEntityBaseReactorHeatMonitor) tile).isConnectionValid()) {
            return WCUtility.getTileEntity(world, pos, TileEntityIC2RemoteReactorMonitor.class).map(t -> t.isOverHeated() ? state.func_177226_a(RENDER_TYPE, BlockIC2ReactorMonitor.RenderType.OVER_HEAT) : state.func_177226_a(RENDER_TYPE, BlockIC2ReactorMonitor.RenderType.NORMAL)).orElse(state.func_177226_a(RENDER_TYPE, BlockIC2ReactorMonitor.RenderType.NOT_FOUND));
        }
        return state.func_177226_a(RENDER_TYPE, BlockIC2ReactorMonitor.RenderType.NOT_FOUND);
    }
}
