package worldcontrolteam.worldcontrol.items;

import net.minecraft.client.util.ITooltipFlag;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.ActionResult;
import net.minecraft.util.EnumActionResult;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.EnumHand;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.text.TextComponentString;
import net.minecraft.world.World;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import worldcontrolteam.worldcontrol.api.thermometer.IHeatSeeker;
import worldcontrolteam.worldcontrol.utils.WCUtility;

import java.util.List;

public class ItemThermometer extends WCBaseItem {

    private static List<IHeatSeeker> heatTypes;

    public ItemThermometer() {
        super("thermometer");
        this.func_77625_d(1);
        this.func_77656_e(102);
    }

    public static void addInHeatTypes(List<IHeatSeeker> types) {
        heatTypes = types;
    }

    @Override
    public EnumActionResult func_180614_a(EntityPlayer player, World world, BlockPos pos, EnumHand hand, EnumFacing facing, float hitX, float hitY, float hitZ) {
        if (!heatTypes.isEmpty()) {
            ItemStack stack = player.func_184586_b(hand);
            if (!stack.func_77942_o()) {
                NBTTagCompound tagCompound = new NBTTagCompound();
                tagCompound.func_74768_a("type", 0);
                stack.func_77982_d(tagCompound);
            }
            if (stack.func_77978_p() != null) {
                int toUse = stack.func_77978_p().func_74762_e("type");
                IHeatSeeker user = heatTypes.get(toUse);
                if (user.canUse(world, pos, world.func_175625_s(pos))) {
                    if (!world.field_72995_K)
                        player.func_145747_a(new TextComponentString(WCUtility.translateFormatted("thermometer.chat_info", user.getHeat(world, pos, world.func_175625_s(pos)))));
                    stack.func_77972_a(10, player);
                    return EnumActionResult.SUCCESS;
                }
            }
        }
        return EnumActionResult.PASS;
    }

    @Override
    public ActionResult<ItemStack> func_77659_a(World world, EntityPlayer player, EnumHand hand) {
        ItemStack itemStack = player.func_184586_b(hand);
        if (player.func_70093_af()) {
            if (!heatTypes.isEmpty()) {
                if (itemStack.func_77942_o()) {
                    NBTTagCompound tag = itemStack.func_77978_p();
                    int currentType = tag.func_74762_e("type");
                    if (currentType + 1 < heatTypes.size()) {
                        currentType++;
                        tag.func_74768_a("type", currentType);
                        itemStack.func_77982_d(tag);
                    } else tag.func_74768_a("type", 0);
                } else {
                    NBTTagCompound tagCompound = new NBTTagCompound();
                    tagCompound.func_74768_a("type", 0);
                    itemStack.func_77982_d(tagCompound);
                }
                if (world.field_72995_K) {
                    player.func_145747_a(new TextComponentString(
                            WCUtility.translateFormatted("thermometer.switchTo", WCUtility.translate("thermometer.mode." + heatTypes.get(itemStack.func_77978_p().func_74762_e("type")).getUnloalizedName()))
                    ));
                }
                return new ActionResult(EnumActionResult.SUCCESS, itemStack);
            }
        }
        return new ActionResult(EnumActionResult.PASS, itemStack);
    }

    @SideOnly(Side.CLIENT)
    @Override
    public void func_77624_a(ItemStack stack, World world, List<String> tooltip, ITooltipFlag advanced) {
        try {
            tooltip.add(WCUtility.translateFormatted("thermometer.mode", WCUtility.translate("thermometer.mode." + heatTypes.get(stack.func_77978_p().func_74762_e("type")).getUnloalizedName())));
        } catch (NullPointerException e) {
            tooltip.add(WCUtility.translateFormatted("thermometer.mode", WCUtility.translate("thermometer.unset")));
        }
    }
}
